#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <pthread.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/types.h>
#include "wwork.h"
#include "wvarpi.h"
#include "warpi.h"
#include "types.h"

int setx;
int sety;

U16 startx;
U16 starty;
U8  valerr;
//предельные и средне значения кадра
U8  levmin; //мнимальное
U8  levmax; //маклсимальное
U8  levn;   //среднее
//
pthread_t               hWorkProcess;
pthread_mutex_t         WorkMutex;
int                     WorkWork;
//
U8  wvbuf[640][480];
//координаты начала региона
int strtxr;
int strtyr;
//размер региона
int szxr;
int szyr;
//шаг в регионе
int stepr;
U8  region[640][480];
//
FMAT1   fmat1;
HIST    hist;
HIST    histregion;


int StartWork(void)
{
    pthread_attr_t 	tattr;
    //параметры для отделяемых потоков
    pthread_attr_init(&tattr);
    pthread_attr_setdetachstate(&tattr, PTHREAD_CREATE_DETACHED);
    //
    //mutex create
    if(!(pthread_mutex_init(&WorkMutex,NULL) == 0))
        return 3;
    pthread_create(&hWorkProcess, &tattr, wWork_process, NULL);
    WorkWork = 1; //установка флага работы
    //
    return 0;
}

//подсчёт мин. сред. макс.
void wMathExtr(void)
{
    U8  ln;
    U8  lev;
    int lcntx = 0;
    int lcnty = 0;
    int sumlev = 0;
    levmin = 255;
    levmax = 0;
    while(lcnty < 480)
    {
        lcntx = 0;
        while(lcntx < 640)
        {
            lev = wvbuf[lcntx][lcnty];
            sumlev += lev;
            if(lev < levmin)
                levmin = lev;
            if(lev > levmax)
                levmax = lev;
            lcntx++;
        }
        lcnty++;
    }
    levn = sumlev /(640 * 480);
}

//заполнение фрагмента матрицы1
int fMatrix1(U8 err, U16 sx, U16 sy, U8 lev)
{
    U16 xl, xr;
    U16 yu, yd;
    int cntfill = 0;
    //
    yu  = sy;
    fmat1.mat1x1 = 640;
    fmat1.mat1x2 = 0;
    while(yu > 0)
    {
        xl = sx;
        while(xl > 0)
        {
            //верхний левый угол
            if((int)(err) < abs((int)(wvbuf[xl][yu]) - (int)(lev)))
            {
                fmat1.mat1x1 = xl;
                fmat1.mat1y1 = yu;
                break;
            }
            if(fmat1.matrix1[xl][yu] != _set_matrix_lev)
            {
                fmat1.matrix1[xl][yu] = _set_matrix_lev;
                cntfill++;
            }
            xl--;
        }
        xr = sx;
        while(xr < 640)
        {
            //верхний правый угол
            if((int)(err) < abs((int)(wvbuf[xr][yu]) - (int)(lev)))
            {
                fmat1.mat1x2 = xr;
                fmat1.mat1y2 = yu;
                break;
            }
            if(fmat1.matrix1[xr][yu] != _set_matrix_lev)
            {
                fmat1.matrix1[xr][yu] = _set_matrix_lev;
                cntfill++;
            }
            xr++;
        }
        if((sx == xl) && (xr == sx))
            break;
        yu--;
    }
    //mat1y1 = yu;
    //mat1y2 = yu;
    yd  = sy;
    fmat1.mat1x3 = 0;
    fmat1.mat1x4 = 640;
    while(yd < 480)
    {
        xl = sx;
        while(xl > 0)
        {
            if((int)(err) < abs((int)(wvbuf[xl][yd]) - (int)(lev)))
            {
                //нижний левый угол
                fmat1.mat1x4 = xl;
                fmat1.mat1y4 = yd;
                break;
            }
            if(fmat1.matrix1[xl][yd] != _set_matrix_lev)
            {
                fmat1.matrix1[xl][yd] = _set_matrix_lev;
                cntfill++;
            }
            xl--;
        }
        xr = sx;
        while(xr < 640)
        {
            //нижний правый угол
            if((int)(err) < abs((int)(wvbuf[xr][yd]) - (int)(lev)))
            {
                fmat1.mat1x3 = xr;
                fmat1.mat1y3 = yd;
                break;
            }
            fmat1.matrix1[xr][yd] = _set_matrix_lev;
            xr++;
            cntfill++;
        }
        if((sx == xl) && (xr == sx))
            break;
        yd++;
    }
    return cntfill;
}

//заполнение элементов матрицы1
int fillMatrix1(float ferr, U16 sx, U16 sy)
{
    U8  err = (U8)((((((float)(levmax - levmin)) / 100.0) ) * ferr));
    U16 xl, xr;
    U16 yu, yd;
    U8  lev = wvbuf[sx][sy];
    fmat1.cntfill   = 0;
    memset(&fmat1.matrix1[0][0], 0, 640 * 480);
    fmat1.matrix1[sx][sy] = _set_matrix_lev;
    //
    fmat1.cntfill += fMatrix1(err, sx,sy,lev);
    //от центра влево
    xl = sx;
    while(xl > 0)
    {
        if(fmat1.matrix1[xl][sy] != _set_matrix_lev)
        {
            xl++;
            fmat1.cntfill += fMatrix1(err, xl, sy, lev);
            break;
        }
        xl--;
    }
    //от центра вправо
    xr = sx;
    while(xr < 640)
    {
        if(fmat1.matrix1[xl][sy] != _set_matrix_lev)
        {
            xr--;
            fmat1.cntfill += fMatrix1(err, xr, sy, lev);
            break;
        }
        xr++;
    }
    //
   // fmat1.cntfill += fMatrix1(err, xl, sy,lev);
    //fmat1.cntfill += fMatrix1(err, fmat1.mat1x2,sy,lev);
    //fmat1.cntfill += fMatrix1(err, sx,fmat1.mat1y3,lev);
    //fmat1.cntfill += fMatrix1(err, sx,fmat1.mat1y4,lev);

    //
    fmat1.start_fillmat1    = false;
    return 1;
}

//заполнение региона
void fillRegion(void)
{
    int cntx;
    int cnty    = strtyr;
    memset(&region[0][0], 0, 640 * 480);
    //X
    while(cnty < strtyr + szyr)
    {
        cntx    = strtxr;
        while(cntx < strtxr + szxr)
        {
            region[cntx][cnty] = _sint;
            cntx++;
        }
        cnty += stepr;
    }
    //Y
    cntx    = strtxr;
    while(cntx < strtxr + szxr)
    {
        cnty    = strtyr;
        while(cnty < strtyr + szyr)
        {
            region[cntx][cnty] = 32;
            cnty++;
        }
        cntx += stepr;
    }
}

//заполнение гистограммы
void Hist(void)
{
    U16 shx, cntx;
    U16 shy, cnty;
    float   histx;
    float   histy;
    //проверка границ
    if(((int)(hist.startx) - _hist_size_x/2) < 0)
        hist.startx += _hist_size_x/2;
    if(((int)(hist.startx) + _hist_size_x/2) >= 640)
        hist.startx -= _hist_size_x/2;
    if(((int)(hist.starty) - _hist_size_y/2) < 0)
        hist.starty += _hist_size_y/2;
    if(((int)(hist.starty) + _hist_size_y/2) >= 480)
        hist.starty -= _hist_size_x/2;
    shx = hist.startx -_hist_size_x/2;
    shy = hist.starty -_hist_size_y/2;
    //определение горизонтали
    cntx = 0;
    while(cntx < _hist_size_x)
    {
        cnty = 0;
        histx = 0;
        while(cnty < _hist_size_y)
        {
            histx += (float)(wvbuf[shx + cntx][shy + cnty]);
            cnty++;
        }
        hist.histx[cntx] = histx;
        cntx++;
    }
    //определение по вертикали
    cnty = 0;
    while(cnty < _hist_size_y)
    {
        cntx = 0;
        histy = 0;
        while(cntx < _hist_size_x)
        {
            histy += (float)(wvbuf[shx + cntx][shy + cnty]);
            cntx++;
        }
        hist.histy[cnty] = histy;
        cnty++;
    }
    hist.work = false;
}

//заполнение гистограммы2
void HistRegion(U16 xr, U16 yr)
{
    U16 shx, cntx;
    U16 shy, cnty;
    float   histx;
    float   histy;
    histregion.startx = xr;
    histregion.starty = yr;
    //проверка границ
    if(((int)(histregion.startx) - _hist_size_x/2) < 0)
        histregion.startx += _hist_size_x/2;
    if(((int)(histregion.startx) + _hist_size_x/2) >= 640)
        histregion.startx -= _hist_size_x/2;
    if(((int)(histregion.starty) - _hist_size_y/2) < 0)
        histregion.starty += _hist_size_y/2;
    if(((int)(histregion.starty) + _hist_size_y/2) >= 480)
        histregion.starty -= _hist_size_x/2;
    shx = histregion.startx -_hist_size_x/2;
    shy = histregion.starty -_hist_size_y/2;
    //определение горизонтали
    cntx = 0;
    while(cntx < _hist_size_x)
    {
        cnty = 0;
        histx = 0;
        while(cnty < _hist_size_y)
        {
            histx += (float)(wvbuf[shx + cntx][shy + cnty]);
            cnty++;
        }
        histregion.histx[cntx] = histx;
        cntx++;
    }
    //определение по вертикали
    cnty = 0;
    while(cnty < _hist_size_y)
    {
        cntx = 0;
        histy = 0;
        while(cntx < _hist_size_x)
        {
            histy += (float)(wvbuf[shx + cntx][shy + cnty]);
            cntx++;
        }
        histregion.histy[cnty] = histy;
        cnty++;
    }
    histregion.work = false;
}


//рабочий поток
void * wWork_process(void * pr)
{
    strtxr  = _strtxr;
    strtyr  = _strtyr;
    szxr  = _szxr;
    szyr  = _szyr;
    stepr = _stepr;
    //
    while(WorkWork)
    {
        pthread_mutex_lock(&WorkMutex);
        //
        wRdCam(&wvbuf[0][0]);
        wMathExtr();
        /*if(fmat1.start_fillmat1)
        {
            fillMatrix1((float)(valerr), startx,starty);
            startx = 0;
            starty = 0;
        }*/
        if(hist.work)
            Hist();
        HistRegion(320,240);
        //
        pthread_mutex_unlock(&WorkMutex);
        usleep(_sleep_work);
    }
    pthread_exit(0);
}

//установка шага региона
int wSetStep(int st)
{
    pthread_mutex_lock(&WorkMutex);
    stepr = st;
    pthread_mutex_unlock(&WorkMutex);
    return 0;
}

//чтение региона
int wRdRegion(U8 * reg)
{
    pthread_mutex_lock(&WorkMutex);
    memcpy(reg, &region[0][0], 640 * 480);
    pthread_mutex_unlock(&WorkMutex);
    return 0;
}

//чтение первой матрицы
int wRdMatrix1(U8 * matr1)
{
    pthread_mutex_lock(&WorkMutex);
    memcpy(matr1, &fmat1.matrix1[0][0], 640 * 480);
    pthread_mutex_unlock(&WorkMutex);
    return 0;
}

//старт заполнения матрицы1
int wStartMatrix1(U16 sx, U16 sy, U8 verr)
{
    pthread_mutex_lock(&WorkMutex);
    startx                  = sx;
    starty                  = sy;
    valerr                  = verr;
    fmat1.start_fillmat1    = true;
    pthread_mutex_unlock(&WorkMutex);
    return 0;
}

//старт формирования гистограммы
int wStartHist(U16 sx, U16 sy)
{
    pthread_mutex_lock(&WorkMutex);
    hist.startx = sx;
    hist.starty = sy;
    hist.work   = true;
    pthread_mutex_unlock(&WorkMutex);
    return 0;
}
